

#     MIDAS Access Client  for the  DataBaseAccess service

global env
source [file join $env(MIDASBASE) SOAP tcl MIDASAccessClient.tcl]    ;#   load default support procedures

global DataBaseAccessServerHost DataBaseAccessServerPort
global SOAPServerHost SOAPServerPort

if {[info exists DataBaseAccessServerHost] == 0} then {set DataBaseAccessServerHost $SOAPServerHost}
if {[info exists DataBaseAccessServerPort] == 0} then {set DataBaseAccessServerPort $SOAPServerPort}

variable uri "urn:DataBaseAccessServer"
variable proxy "http://$DataBaseAccessServerHost:$DataBaseAccessServerPort/DataBaseAccessServer"

set DataBaseAccessClient__TimeOut 1000

SOAP::create DataBaseAccessClient__nodes -proxy $proxy -uri $uri -timeout $DataBaseAccessClient__TimeOut \
     -name DBnodes \
     -params {nodeName string pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create DataBaseAccessClient__set -proxy $proxy -uri $uri -timeout $DataBaseAccessClient__TimeOut \
     -name DBset \
     -params {nodeName string valueName string data string type string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply
     
SOAP::create DataBaseAccessClient__get -proxy $proxy -uri $uri -timeout $DataBaseAccessClient__TimeOut \
     -name DBget \
     -params {nodeName string valueName string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create DataBaseAccessClient__delete -proxy $proxy -uri $uri -timeout $DataBaseAccessClient__TimeOut \
     -name DBdelete \
     -params {nodeName string valueName string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply
     
SOAP::create DataBaseAccessClient__values -proxy $proxy -uri $uri -timeout $DataBaseAccessClient__TimeOut \
     -name DBvalues \
     -params {nodeName string pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create DataBaseAccessClient__type -proxy $proxy -uri $uri -timeout $DataBaseAccessClient__TimeOut \
     -name DBtype \
     -params {nodeName string valueName string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create DataBaseAccessClient__Get-LastError -proxy $proxy -uri $uri -timeout 1000 \
     -name Get-LastError \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create DataBaseAccessClient__Get-Information -proxy $proxy -uri $uri -timeout 1000 \
     -name Get-Information \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create DataBaseAccessClient__ServerVerbose -proxy $proxy -uri $uri -timeout 1000 \
     -name ServerVerbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create DataBaseAccessClient__ServerImplementation -proxy $proxy -uri $uri -timeout 1000 \
     -name ServerImplementation \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

package provide DataBaseAccessClient 1.0
