

#    MIDAS Access Client  for the  QServer service

global env
source [file join $env(MIDASBASE) SOAP tcl MIDASAccessClient.tcl]    ;#   load default support procedures

global QServerHost QServerPort

if {[info exists QServerHost] == 0} then {set QServerHost localhost}
if {[info exists QServerPort] == 0} then {set QServerPort 8015}

variable uri "urn:QServer"
variable proxy "http://$QServerHost:$QServerPort/QServer"

SOAP::create QClient__QServerInit -proxy $proxy -uri $uri -timeout 5000 \
     -name QServerInit \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create QClient__QServerExit -proxy $proxy -uri $uri -timeout 5000 \
     -name QServerExit \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create QClient__QServerWrite -proxy $proxy -uri $uri -timeout 5000 \
     -name QServerWrite \
     -params {Address int Count int Value string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create QClient__QServerRead -proxy $proxy -uri $uri -timeout 5000 \
     -name QServerRead \
     -params {Address int Count int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create QClient__QServerGetEvent -proxy $proxy -uri $uri -timeout 5000 \
     -name QServerGetEvent \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create QClient__QServerVerbose -proxy $proxy -uri $uri -timeout 5000 \
     -name QServerVerbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 



package provide QClient 1.0
