


#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable Present 
    variable CorePresent
    variable SegmentPresent 
    variable FpgaList
    variable FpgaIDs 
    variable Fpga 
    variable ShortTimeOut 5000

    variable Digitizer      -1
    variable NumDigitizer    0
    variable DigitizerList   {}

    variable Offset

    for {set i 1} {$i <= 7} {incr i} {set Offset($i) 0}

    set FpgaList {"Use Probe Hardware"}
    set FpgaIDs {}       ;# 0 1 2 3 8 9 10 11 12
    set Fpga "Use Probe Hardware"

#   access procedures

    set CorePresent 0        ;#   for current digitizer
    set SegmentPresent 0     ;#   for current digitizer
    for {set i 0} {$i <= 12} {incr i} {set Present($i) 0}     ;# index is fpga ID

    source Common.tcl

    proc InsertLog {s} {
        variable LogText
        variable LogCount

        incr LogCount
        if {$LogCount == 100} {set LogText ""; set LogCount 0}

        append LogText "$s\n"
        return ""
    }

   proc  show_variables {} {
       variable LogText
       variable ShowLogFlag
       variable JS
       variable Digitizer
       variable Fpga 
       variable Offset

         if {$ShowLogFlag == 1} {
             set LogText ""
             InsertLog "Digitizer=$Digitizer; Fpga=$Fpga"
             for {set i 1} {$i <= 7} {incr i} {InsertLog "Offset($i)=[set Offset($i)]"}
         }  else {
             append JS "alert(\"Digitizer=$Digitizer; Fpga=$Fpga"
             for {set i 1} {$i <= 7} {incr i} {append JS "; Offset($i)=[set Offset($i)]"}
             append JS "\");"
         }
   }

   proc do_parameters {} {
        variable cgidata
        variable Offset
        variable LogFlag

        for {set i 2} {$i < [llength $cgidata]} {incr i} {

            set name [lindex $cgidata $i]
            incr i
            set value [lindex $cgidata $i]

            switch -glob $name {
               Offset*_value  {
                   set n [string range $name 6 6]
                   set Offset($n) $value
                   if {$LogFlag == 1} {InsertLog "Offset($n) = $value"}
               }

               Fpga -
               Digitizer  {
                    variable $name
                    set $name $value
                    if {$LogFlag == 1} {InsertLog "$name = $value"}
               }
            }
        }
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogText
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               do_parameters
                   set w [lindex $cgidata 1]
               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {set LogText ""}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   PROBE    {
                       for {set i 2} {$i < [llength $cgidata]} {incr i} {
                          set name [lindex $cgidata $i]
                          incr i
                          set value [lindex $cgidata $i]
                          switch $name {
                             Digitizer  {set $name $value}
                             default    {}
                          }
                       }
                       click-probe
                   }

                   PROM       {click-readprom}

                   SELECT     {do_UpdateOffsets}

                   SETUP2     {click-setupall}
                   SETUP1     {click-setupdigitizer}
                   SETUP0     {click-setupfpga}
                   OFFSET*    {click-offset [string range $w 6 end]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
     }

    EnumerateDigitizers

}   ;# end of if {$started == 0}

